using System;
using System.Collections.Generic;
using System.Data;
using Orchard.ContentManagement.Drivers;
using Orchard.ContentManagement.MetaData;
using Orchard.ContentManagement.MetaData.Builders;
using Orchard.Core.Contents.Extensions;
using Orchard.Data.Migration;
using TagMenuWidgets.Models;

namespace TagMenuWidgets {
    public class Migrations : DataMigrationImpl {

        public int Create() {
			// Creating table TagMenuWidgetRecord
			SchemaBuilder.CreateTable("TagMenuWidgetRecord", table => table
				.ContentPartRecord()
				.Column("TagList", DbType.String)
				.Column("MaxItems", DbType.Int32)
				.Column("ExcludeCurrentItemIfMatching", DbType.Boolean)
				.Column("MustHaveAllTags", DbType.Boolean)
				.Column("ShowListOnly", DbType.Boolean)
			);

            ContentDefinitionManager.AlterPartDefinition(
    typeof(TagMenuWidgetPart).Name, cfg => cfg.Attachable());

            return 1;
        }

        public int UpdateFrom1()
        {
            // Create a new widget content type with our map
            ContentDefinitionManager.AlterTypeDefinition("TagMenuWidget", cfg => cfg
                .WithPart("TagMenuWidgetPart")
                .WithPart("WidgetPart")
                .WithPart("CommonPart")
                .WithSetting("Stereotype", "Widget"));
            return 2;
        }
    }
}