﻿using System.ComponentModel.DataAnnotations;
using Orchard.ContentManagement;
using Orchard.ContentManagement.Records;

namespace TagMenuWidgets.Models
{
    public class TagMenuWidgetRecord : ContentPartRecord
    {
        public virtual string TagList { get; set; }
        public virtual int MaxItems { get; set; }
        public virtual bool ExcludeCurrentItemIfMatching { get; set; }
        public virtual bool MustHaveAllTags { get; set; }
        public virtual bool ShowListOnly { get; set; }
    }

    public class TagMenuWidgetPart : ContentPart<TagMenuWidgetRecord>
    {
        [Required]
        public string TagList
        {
            get { return Record.TagList; }
            set { Record.TagList = value; }
        }

        [Required]
        public int MaxItems
        {
            get { return Record.MaxItems; }
            set { Record.MaxItems = value; }
        }

        public bool ExcludeCurrentItemIfMatching
        {
            get { return Record.ExcludeCurrentItemIfMatching; }
            set { Record.ExcludeCurrentItemIfMatching = value; }
        }

        public bool MustHaveAllTags
        {
            get { return Record.MustHaveAllTags; }
            set { Record.MustHaveAllTags = value; }
        }

        public bool ShowListOnly
        {
            get { return Record.ShowListOnly; }
            set { Record.ShowListOnly = value; }
        }
    }
}